# 零、前言

Python 是一种多范式编程语言，已成为数据科学家进行数据分析，可视化和机器学习的首选语言。

您将首先学习如何为 Python 建立正确的数据分析环境。 在这里，您将学习安装正确的 Python 发行版，以及使用 Jupyter 笔记本和建立数据库。 之后，您将深入研究 Python 的 NumPy 包 -- Python 的强大扩展以及高级数学函数。 您将学习如何创建 NumPy 数组，以及如何使用不同的数组方法和函数。 然后，您将探索 Python 的 pandas 扩展，在那里您将学习数据的子集，并深入研究使用 pandas 的数据映射。 您还将学习通过对数据集进行排序和排序来管理它们。

到本书结尾，您将学习对数据进行索引和分组以进行复杂的数据分析和处理。

## 这本书是给谁的

如果您是 Python 开发人员，并且想迈出第一步进入数据分析领域，那么这就是您一直在等待的书！

## 充分利用这本书

Python 3.4.x 或更高版本。 在 Debian 及其衍生产品（Ubuntu）上：python，python-dev 或 python3-dev。 在 Windows 上： [www.python.org](http://www.python.org) 上的官方 python 安装程序就足够了：

*   NumPy
*   Pandas


## 使用约定

本书中使用了许多文本约定。

`CodeInText`：表示文本中的词，数据库表名称，文件夹名称，文件名，文件扩展名，路径名，伪 URL，用户输入和 Twitter 句柄。 这是一个示例：“然后用这个符号与`arr1`相乘”。

任何命令行输入或输出的编写方式如下：

```py
 conda install selenium 
```

**粗体**：表示您在屏幕上看到的新术语，重要单词或顺序。 例如，菜单或对话框中的单词会出现在这样的文本中。 这是一个示例：“在此添加单元，然后单击再次运行单元”。 

警告或重要提示如下所示。 提示和技巧如下所示。