# 零、前言

如果您想磨练数据科学领域的技能，那么有很多书籍和课程的难度会有所不同。 通常会发生的情况是，您开始研究入门资源，然后继续使用更深入的技术资源，以尝试新的领域或技术。 如果您一段时间以来一直遵循这种学习方式，那么您一定已经意识到这将变得非常耗时。 作为终身学习者，我们需要书本能更紧凑地表示知识和经验，这需要在理论和实践之间取得适当的平衡。 本书旨在将初学者，中级和高级概念结合在一起，这是我们从头开始积累您的知识的谦虚努力。

本书假定以前没有科学计算的背景，并且将通过实际例子介绍各种主题。 有时可能感觉像是将各个主题随机组合在一起，而本书的流程并没有遵循一条一致的道路。 这是我们故意做出的决定，目的是让您对几种不同的主题和应用有所了解。

我们希望您能读这本书，以更广泛地了解科学计算，并掌握 NumPy 的精髓和其他支持 Python 的科学库，例如 SciPy 和 Scikit-Learn。

# 这本书是给谁的

本书适用于希望在数据科学领域获得更多知识的每个人。 如果您是 Python 程序员，数据分析师，数据工程师或数据科学爱好者，并且希望掌握 NumPy 的复杂性并为您的数字和科学构建解决方案，那么《使用 NumPy 掌握数字计算问题》非常适合您。 希望您熟悉数学以充分利用本书。

# 充分利用这本书

1.  基本的 Python 编程知识肯定会有所帮助，尽管并非绝对必要
2.  Python 3 的 Anaconda 发行版足以覆盖本书中使用的大多数示例

# 使用约定

本书中使用了许多文本约定。

`CodeInText`：表示文本中的词，数据库表名称，文件夹名称，文件名，文件扩展名，路径名，伪 URL，用户输入和 Twitter 句柄。 这是一个示例：“此函数中的另一个重要参数是`learning_rate`。”

代码块设置如下：

```py
'sepal width (cm)',
'petal length (cm)',
'petal width (cm)'])
```

任何命令行输入或输出的编写方式如下：

```py
$ sudo apt-get update
$ sudo apt-get upgrade
```

**粗体**：表示您在屏幕上看到的新术语，重要单词或顺序。 例如，菜单或对话框中的单词会出现在这样的文本中。 这是一个示例：“**因变量**是我们要预测的变量。”

警告或重要提示显示如下，提示和技巧显示如下。
