# 零、前言

在大数据时代，寻找有价值的业务见解类似于在大海捞针。 可视化在不断增加的数据量和各种数据中找到这些块时起着至关重要的作用。 Matplotlib 凭借其丰富的可视化功能，使探索性数据分析过程变得用户友好且更加高效。

Matplotlib 的核心功能非常强大，许多内部和第三方辅助工具包进一步增强了。 市场上的任何书籍都仅覆盖其全部功能的一小部分。 在本书中，我们介绍了 Matplotlib 的完整核心功能及其许多流行的工具包。

Matplotlib 在使用 Python 生态系统的机器学习从业人员和研究人员中很受欢迎。 凭借其丰富的功能，它可以用于商业智能和运营报告应用。 在本书中，我们尝试介绍这些应用中的示例。

尽管基于秘籍的秘籍方法使本书成为快速解决方案的参考指南，但我们已经涵盖了足够的理论背景，对于初学者来说也很容易。

## 这本书是给谁的

本书适用于数据分析师，业务分析师，数据科学家和 Python 开发人员，他们正在为各种可视化应用寻求快速解决方案，例如临时报告，专业仪表板，探索性数据分析，交互分析，选定中的嵌入式可视化文件 GUI 工具箱和 Web 应用，三维图和地理地图。

那些对开发商业智能，机器学习，科学或工程应用感兴趣的人也会从与这些学科相关的秘籍中受益。

## 充分利用这本书

除了第 9 章，“开发交互式绘图”和第 10 章，“嵌入图形用户界面”外，Python 的基本知识足以理解本书的内容。 。 这两章介绍需要中级 Python 编程经验的交互式绘图和嵌入式应用。

许多 Python 发行版自动包含 Matplotlib 及其所有依赖项。 如果尚未安装任何标准的 Python 发行版，则可以在[这个页面](https://matplotlib.org/users/installing.html)上按照的安装过程来安装 Matplotlib 及其相关的依赖项。

## 使用约定

本书中使用了许多文本约定。

`CodeInText`：表示文本中的词，数据库表名称，文件夹名称，文件名，文件扩展名，路径名，伪 URL，用户输入和 Twitter 句柄。 例如：“我们将按照`.txt`，`.csv`和`.xlsx`文件，分为三个部分。”

代码块设置如下：

```py
import matplotlib.pyplot as plt
import pandas as pd
import numpy as np
from matplotlib import cm
```

**粗体**：表示您在屏幕上看到的新术语，重要单词或顺序。 例如，菜单或对话框中的单词会出现在这样的文本中。 这是一个示例：“当您运行程序并单击**下一步**时，您将看到以下三个图，代表每个群集，如每个标题中所示。”

Warnings or important notes appear like this.Tips and tricks appear like this.

## 标题

在本书中，您会发现几个经常出现的标题（“准备”，“操作步骤”，“工作原理”，和“另见”）。

要给出有关如何完成秘籍的明确说明，请按以下说明使用这些部分：

## 准备

本节告诉您在秘籍中会有什么期望，并介绍如何设置秘籍所需的任何软件或任何初步设置。

## 操作步骤

本节包含遵循秘籍所需的步骤。

## 工作原理

本节通常包括对上一节中发生的情况的详细说明。

## 更多

本节包含有关秘籍的其他信息，以使您对秘籍有更多的了解。

## 另见

本节提供了指向该秘籍其他有用信息的有用链接。

