# 零、前言

matplotlib 是用于绘图的 Python 模块，并且是科学 Python 模块套件的组件。 matplotlib 允许您使用全面的 API 轻松定制专业级图形，以自定义图形的各个方面。 在本书中，我们将介绍不同类型的图形以及如何调整图形以满足您的需求。 秘籍是正交的，您将能够非常快速地编写自己的解决方案。

## 这本书涵盖的内容

第 1 章，“第一步”介绍了使用 matplotlib 的基础知识。 基本图形类型以最少的示例介绍。

第 2 章，“自定义颜色和样式”涵盖了如何控制图形的颜色和样式-包括标记，线条粗细，线条图案以及使用颜色表为图的几个项目着色。

第 3 章，“处理标注”涵盖如何标注图形-这包括添加轴域图例，箭头，文本框和形状。

第 4 章，“处理图形”涵盖了如何准备复杂图形-这包括合成多个图形，控制长宽比，轴范围和坐标系。

第 5 章，“处理文件输出”涵盖位图或向量格式的文件输出。 对诸如透明度，分辨率和多页之类的问题进行了详细研究。

第 6 章，“处理地图”涵盖了绘制类似矩阵的数据-包括地图，颤动图和流图。

第 7 章，“处理 3D 图形”涵盖了 3D 图-包括散点图，线图，表面图和条形图。

第 8 章，“用户界面”涵盖了一组用户界面集成解决方案，从简单，极简到复杂。

## 这本书需要什么

本书中的示例是为 Matplotlib 1.2 和 Python 2.7 或 3 编写的。

大多数示例都依赖于 NumPy 和 SciPy。 一些示例需要 SymPy，而另一些示例则需要 LaTeX。

## 这本书适合谁

这本书适合有一些 Python 和科学背景的读者。

## 约定

在本书中，您会发现许多可以区分不同类型信息的文本样式。 以下是这些样式的一些示例，并解释了其含义。

文本中的代码字，数据库表名称，文件夹名称，文件名，文件扩展名，路径名，虚拟 URL，用户输入和 Twitter 句柄如下所示：“我们可以通过使用`include`指令来包含其他上下文。”

代码块设置如下：

```py
[default]
exten => s,1,Dial(Zap/1|30)
exten => s,2,Voicemail(u100)
exten => s,102,Voicemail(b100)
exten => i,1,Voicemail(s0)
```

当我们希望引起您对代码块特定部分的注意时，相关的行或项目将以粗体显示：

```py
[default]
exten => s,1,Dial(Zap/1|30)
exten => s,2,Voicemail(u100)
exten => s,102,Voicemail(b100)
exten => i,1,Voicemail(s0)
```

任何命令行输入或输出的编写方式如下：

```py
## cp /usr/src/asterisk-addons/configs/cdr_mysql.conf.sample
 /etc/asterisk/cdr_mysql.conf

```

**新术语**和**重要词**以粗体显示。 您在屏幕上看到的单词，例如在菜单或对话框中，将以如下形式出现：“单击**下一步**按钮将您移至下一个屏幕”。

#### 注意

警告或重要提示会出现在这样的框中。

#### 提示

提示和技巧如下所示。

